package de.npid7.serverlite.Helpers;

import com.google.gson.JsonArray;
import com.google.gson.JsonElement;
import java.util.Vector;

public class Wordlist {
  Vector<String> wordlist = new Vector<>();

  public Wordlist() {}

  public void fromJsonArray(JsonArray a) {
    if (a == null) {
      return;
    }
    for (JsonElement e : a) {
      wordlist.add(e.getAsString());
    }
  }

  public JsonArray toJsonArray() {
    JsonArray a = new JsonArray();
    for (String s : wordlist) {
      a.add(s);
    }
    return a;
  }

  public boolean add(String s) {
    // wra -> With rights allowed
    if (find(s) != null) {
      return false;
    }
    wordlist.add(s);
    return true;
  }

  public boolean remove(String s) {
    String e = find(s);
    if (e == null) {
      return false;
    }
    wordlist.remove(e);
    return true;
  }

  public String find(String word) {
    for (String s : wordlist) {
      if (s.equalsIgnoreCase(word)) {
        return s;
      }
    }
    return null;
  }

  public boolean isAllowed(String word) {
    String w = find(word);
    if (w != null) {
      return false;
    }
    return true;
  }

  public Vector<String> getList() {
    return wordlist;
  }
}
