package de.npid7.serverlite.Listeners;

import de.npid7.serverlite.Configs.PlayerConfig;
import de.npid7.serverlite.ServerLite;

import org.bukkit.ChatColor;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.AsyncPlayerChatEvent;
import org.bukkit.event.player.PlayerJoinEvent;

public class PlayerListener implements Listener {
  @EventHandler
  public void onPlayerMessage(AsyncPlayerChatEvent e) {
    String msg = e.getMessage();
    String prefix = "";
    String status = ServerLite.getInst().getPlayerConfig().getStatus(e.getPlayer().getUniqueId());
    String statusColor = "";
    if (!status.equals("")) {
      statusColor = ServerLite.getInst().getPluginConfig().getStatusColor(status);
      if (statusColor == null) {
        statusColor = ChatColor.WHITE.toString();
      }
      prefix = "[" + statusColor + status + ChatColor.WHITE.toString() + "] ";
    }
    prefix += "<" + e.getPlayer().getDisplayName() + "> ";
    e.setFormat(prefix + msg);
  }

  @EventHandler
  public void onJoin(PlayerJoinEvent event) {
    Player player = event.getPlayer();
    if (ServerLite.getInst().getPlayerConfig().Find(player.getUniqueId()) == null) {
      ServerLite.getInst().getPlayerConfig().Add(player.getUniqueId(),
          new PlayerConfig.PlayerEntry(
              ServerLite.getInst().getPluginConfig().getDefaultStatus(), player.getName(), false));
      ServerLite.getInst().getPlayerConfig().Save();
    }
  }
}