package de.npid7.serverlite.Tasks;

import de.npid7.serverlite.ServerLite;
import de.npid7.serverlite.Helpers.Spielzeit;
import net.md_5.bungee.api.ChatMessageType;
import net.md_5.bungee.api.chat.TextComponent;
import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.Statistic;
import org.bukkit.entity.Player;
import org.bukkit.scheduler.BukkitRunnable;

public class TablistTask {
  long lastTickNano = System.nanoTime();
  long lastSecondNano = lastTickNano;
  int ticksThisSec = 0;
  double tps = 20.0;
  double mspt = 0.0;
  double total_mspt = 0.0;
  long msptlt;

  private void CalcTPS() {
    long now = System.nanoTime();
    double now_mspt = (now - lastTickNano) / 1000000.0;
    lastTickNano = now;
    total_mspt += now_mspt;
    if (now - lastSecondNano >= 1000000000.0) {
      tps = ticksThisSec;
      // Fake Value
      if (tps == 21)
        tps = 20;
      mspt = total_mspt / ticksThisSec;
      total_mspt = 0;
      ticksThisSec = 0;
      lastSecondNano = now;
    }
    ticksThisSec++;
  }

  public TablistTask() {
    run();
  }

  private void displayTablist() {
    for (Player pl : Bukkit.getServer().getOnlinePlayers()) {
      int playtime = Spielzeit.getHours(pl.getStatistic(Statistic.TOTAL_WORLD_TIME));
      String str = " Stunden";
      if (playtime == 1) {
        str = " Stunde";
      }
      String tpsclr = ChatColor.GREEN.toString();
      if (tps < 18.0 && tps > 15.0) {
        tpsclr = ChatColor.GOLD.toString();
      } else if (tps <= 15 || tps > 20) {
        tpsclr = ChatColor.RED.toString();
      }
      pl.setPlayerListHeader(
          "\n§x§B§1§9§1§6§9§lʟ§x§A§D§8§E§6§8§lᴇ§x§A§A§8§C§6§7§lɢ§x§A§6§8§9§6§6§lᴀ§x§A§2§8§7§6§5§lᴄ§x§9§F§8§4§6§4§lʏ §x§9§8§7§F§6§2§lѕ§x§9§4§7§C§6§0§lᴜ§x§9§0§7§A§5§F§lʀ§x§8§D§7§7§5§E§lᴠ§x§8§9§7§5§5§D§lɪ§x§8§5§7§2§5§C§lᴠ§x§8§2§7§0§5§B§lᴀ§x§7§E§6§D§5§A§lʟ\n"
          + "\n" + ChatColor.GRAY.toString() + "ᴅᴇɪɴ ᴘɪɴɢ" + ChatColor.DARK_GRAY.toString() + ": "
          + ChatColor.GREEN.toString() + pl.getPing() + "   " + ChatColor.GRAY.toString()
          + "ѕᴇʀᴠᴇʀ ᴛᴘѕ" + ChatColor.DARK_GRAY.toString() + ": " + ChatColor.GREEN.toString()
          + tpsclr + String.format("%.1f", tps) + "\n\n" + ChatColor.GRAY.toString() + "ѕᴘɪᴇʟᴢᴇɪᴛ"
          + ChatColor.DARK_GRAY.toString() + ": " + ChatColor.GREEN.toString() + playtime + str
          + "\n");
      pl.setPlayerListFooter("\n");
      String body = "";
      String status = ServerLite.getInst().getPlayerConfig().getStatus(pl.getUniqueId());
      if (!status.equals("")) {
        body += "[";
        String color = ServerLite.getInst().getPluginConfig().getStatusColor(status);
        if (color == null) {
          color = ChatColor.WHITE.toString();
        }
        body += color;
        body += status;
        body += ChatColor.WHITE.toString();
        body += "] ";
      }
      body += ChatColor.WHITE.toString() + pl.getDisplayName();
      body += " " + ChatColor.RED.toString() + pl.getStatistic(Statistic.DEATHS);
      pl.setPlayerListName(body);
      if (ServerLite.getInst().getPlayerConfig().getTimer(pl.getUniqueId())) {
        pl.spigot().sendMessage(ChatMessageType.ACTION_BAR,
            new TextComponent(ChatColor.GOLD.toString()
                + Spielzeit.formatTicks(pl.getStatistic(Statistic.TOTAL_WORLD_TIME))));
      }
    }
  }

  private void run() {
    new BukkitRunnable() {
      @Override
      public void run() {
        CalcTPS();
        displayTablist();
      }
    }.runTaskTimer(ServerLite.getInst(), 0, 0);
  }
}
